'INICIAR REGEDIT.EXE EN MI PC
'Basado en un scrip VBS de Marcial Carls de 2002
'Abrir Regedit con el comportamiento por defecto en Windows anteriores (se abre en Mi PC y no en la ltima clave visitada).

'Recuperar o almacenar datos del registro mediante la clase Microsoft.Win32.Registry
Imports Microsoft.Win32
'Iniciar y detener procesos del sistema local
Imports System.Diagnostics

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Cdigo generado por el Diseador de Windows Forms "

    Public Sub New()
        MyBase.New()

        'El Diseador de Windows Forms requiere esta llamada.
        InitializeComponent()

        'Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'Form reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requerido por el Diseador de Windows Forms
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de Windows Forms requiere el siguiente procedimiento
    'Puede modificarse utilizando el Diseador de Windows Forms. 
    'No lo modifique con el editor de cdigo.
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents LabelInfo As System.Windows.Forms.Label
    Friend WithEvents BotonSalir As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.LabelInfo = New System.Windows.Forms.Label()
        Me.BotonSalir = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'LabelInfo
        '
        Me.LabelInfo.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.LabelInfo.Location = New System.Drawing.Point(8, 8)
        Me.LabelInfo.Name = "LabelInfo"
        Me.LabelInfo.Size = New System.Drawing.Size(520, 32)
        Me.LabelInfo.TabIndex = 1
        Me.LabelInfo.Text = "Arrancando Regedit.exe en la clave ""MiPC""..."
        Me.LabelInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'BotonSalir
        '
        Me.BotonSalir.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.BotonSalir.Location = New System.Drawing.Point(200, 48)
        Me.BotonSalir.Name = "BotonSalir"
        Me.BotonSalir.Size = New System.Drawing.Size(122, 32)
        Me.BotonSalir.TabIndex = 0
        Me.BotonSalir.Text = "Salir (ESC)"
        '
        'Form1
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(108.0!, 108.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi
        Me.ClientSize = New System.Drawing.Size(536, 90)
        Me.Controls.Add(Me.BotonSalir)
        Me.Controls.Add(Me.LabelInfo)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Regedit MiPC"
        Me.ResumeLayout(False)

    End Sub

#End Region

    'al cargar el formulario
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            'no hace falta mostrar el formulario
            Me.Visible = False
            'pulsar ESC equivale a pulsar el botn btSalir
            Me.CancelButton = Me.BotonSalir
            'constante que almacena la cadena con la entrada del registro en la que se guarda la ltima clave visitada,
            'la cadena no empieza por HKEY_CURRENT_USER porque al asignar un valor a la variable clave (RegistryKey)
            'se usa el mtodo OpenSubKey, pasado al campo superior apropiado (CurrentUser en este caso)
            Const cadena As String = "Software\Microsoft\Windows\CurrentVersion\Applets\Regedit"
            'objeto RegistryKey que permite manipular valores del registro con sus mtodos GetValue y SetValue,
            'el mtodo OpenSubKey tiene 2 parmetros:
            '- una cadena con la ruta a la clave
            '- variable booleana para indicar si la clave es modificable (True) o no (False)
            Dim clave As RegistryKey = Registry.CurrentUser.OpenSubKey(cadena, True)
            Dim valor As String
            '
            'para recuperar el valor de la clave LastKey
            'valor = clave.GetValue("LastKey", "?").ToString
            '
            'para asignar un valor a la clave LastKey
            valor = ""
            clave.SetValue("LastKey", valor)
            'comenzar un programa pasando una cadena con el nombre del ejecutable
            'System.Diagnostics.Process.Start("Regedit.exe")
            Process.Start("Regedit.exe")
        Catch pollo As Exception
            'si hay errores, mostrar un aviso
            MessageBox.Show("No ha sido posible ejecutar el programa." + vbCrLf + pollo.Message)
        Finally
            'siempre cerrar este formulario al final
            Me.Close()
        End Try
    End Sub

    'cerrar el formulario desde el botn
    Private Sub BotonSalir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BotonSalir.Click
        Me.Close()
    End Sub

End Class
